Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditionEditor.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditionEditor.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditionEditor.java	(revision 653)
@@ -0,0 +1,891 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.synopticedition.rcp.editors;
+
+import java.util.Collection;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.List;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.text.ITextSelection;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.ISelectionChangedListener;
+import org.eclipse.jface.viewers.ISelectionProvider;
+import org.eclipse.jface.window.Window;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.KeyEvent;
+import org.eclipse.swt.events.KeyListener;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.graphics.Image;
+import org.eclipse.swt.layout.FillLayout;
+import org.eclipse.swt.layout.FormAttachment;
+import org.eclipse.swt.layout.FormData;
+import org.eclipse.swt.layout.FormLayout;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IEditorPart;
+import org.eclipse.ui.IEditorSite;
+import org.eclipse.ui.IPartListener2;
+import org.eclipse.ui.IWorkbenchPartReference;
+import org.eclipse.ui.PartInitException;
+import org.eclipse.ui.part.EditorPart;
+import org.txm.objects.Edition;
+import org.txm.objects.Text;
+import org.txm.rcp.IImageKeys;
+import org.txm.rcp.editors.IEditionEditor;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.synopticedition.rcp.editors.EditionPanel.RGBA;
+import org.txm.synopticedition.rcp.editors.ext.ToolbarButton;
+import org.txm.synopticedition.rcp.messages.SynopticEditionUIMessages;
+import org.txm.utils.logger.Log;
+/**
+ * Call the internal browser of RCP a Texte can be set to browse pages and
+ * others texts of the same base 
+ * 
+ * @author mdecorde.
+ * 
+ */
+public class SynopticEditionEditor extends EditorPart implements IEditionEditor {
+
+	/** The Constant ID. */
+	public final static String ID = SynopticEditionEditor.class.getName(); //$NON-NLS-1$
+	LinkedHashMap<String, EditionPanel> editionPanels = new LinkedHashMap<String, EditionPanel>();
+
+	/** The page_label: show current page name. */
+	org.eclipse.swt.widgets.Text page_text;
+	Label page_label;
+	Composite editionsArea;
+	private String[] editionNames;
+	private Corpus corpus;
+	private Text text;
+	private Button editionsChooser;
+	//private Label editionsLabel;
+	private Composite controlsArea;
+	private Composite toolbarsArea;
+	private Composite supplementaryButtonComposite;
+	private HashSet<ToolbarButton> toolbarButtons = new HashSet<ToolbarButton>();
+	private ISelectionProvider selProvider;
+
+	/**
+	 * Instantiates a new txm browser.
+	 */
+	public SynopticEditionEditor() {
+		selProvider = new ISelectionProvider() {
+			@Override
+			public void setSelection(ISelection selection) { }
+			@Override
+			public void removeSelectionChangedListener(ISelectionChangedListener listener) { }
+			@Override
+			public ISelection getSelection() {
+				ITextSelection sel = new ITextSelection() {
+					@Override
+					public boolean isEmpty() {
+						for (EditionPanel panel : editionPanels.values()) {
+							String s = panel.getTextSelection();
+							if (s.length() > 0) return false;
+						}
+						return true;
+					}
+					@Override
+					public String getText() {
+						for (EditionPanel panel : editionPanels.values()) {
+							String s = panel.getTextSelection();
+							if (s.length() > 0) return s;
+						}
+						return "";
+					}
+					@Override
+					public int getStartLine() {	return 0;}
+					@Override
+					public int getOffset() {return 0;}
+					@Override
+					public int getLength() {return 0;}
+					@Override
+					public int getEndLine() {return 0;}
+				};
+				return sel;
+			}
+
+			@Override
+			public void addSelectionChangedListener(ISelectionChangedListener listener) { }
+		};
+
+	}
+
+	public void setHighlightWordsById(RGBA color, HashSet<String> wordids) {
+		for(EditionPanel panel : editionPanels.values()) {
+			panel.setHighlightWordsById(color, wordids);
+		}
+	}
+
+	public void addHighlightWordsById(RGBA color, String wordid) {
+		for(EditionPanel panel : editionPanels.values()) {
+			panel.addHighlightWordsById(color, wordid);
+		}
+	}
+
+	public void addHighlightWordsById(RGBA color, Collection<String> wordids) {
+		for(EditionPanel panel : editionPanels.values()) {
+			panel.addHighlightWordsById(color, wordids);
+		}
+	}
+
+	public void removeHighlightWordsById(RGBA color, Collection<String> wordids) {
+		for(EditionPanel panel : editionPanels.values()) {
+			panel.removeHighlightWordsById(color, wordids);
+		}
+	}
+
+	public void removeHighlightWordsById(RGBA color, String wordid) {
+		for(EditionPanel panel : editionPanels.values()) {
+			panel.removeHighlightWordsById(color, wordid);
+		}
+	}
+
+	//	/**
+	//	 * 
+	//	 * @param wordids2 all the words to highlight
+	//	 * @param lineids2 the words to highlight better and to scroll to
+	//	 */
+	//	public void highlightWordsById(List<String> wordids, List<String> lineids, int[] pos, String focusid) {
+	//		for(EditionPanel panel : editionPanels.values()) {
+	//			if (panel.getEdition().getName().startsWith("facs")) {
+	//				List<int[]> wordRectangles = new ArrayList<int[]>();
+	//				List<int[]> keywordRectangles = new ArrayList<int[]>();
+	//				if (pos != null) keywordRectangles.add(pos);
+	//				panel.highlightWordsByPositions(wordRectangles, keywordRectangles);
+	//			} else {
+	//				panel.highlightWordsById(wordids, lineids, focusid);
+	//			}
+	//		}
+	//
+	//		updatePageLabel();
+	//		
+	//		
+	//	}
+
+	public void dispose() {
+		if (releaseExtensions()) {
+			super.dispose();
+		}
+	}
+
+	private boolean releaseExtensions() {
+		boolean error = false;
+		for (ToolbarButton tb : toolbarButtons) {
+			try {
+				tb.onClose();
+			} catch(Exception e) {
+				Log.printStackTrace(e);
+				System.out.println("Error while closing editor toolbar button: "+e);
+				error = true;
+			}
+		}
+		return !error;
+	}
+
+	/**
+	 * First page.
+	 */
+	public void firstPage() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.firstPage();
+		updatePageLabel();
+	}
+
+	/**
+	 * Last page.
+	 */
+	public void lastPage() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.lastPage();
+		updatePageLabel();
+	}
+
+	/**
+	 * Previous page.
+	 */
+	public void previousPage() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.previousPage();
+		updatePageLabel();
+	}
+
+	/**
+	 * Next page.
+	 */
+	public void nextPage() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.nextPage();
+		updatePageLabel();
+	}
+
+	/**
+	 * Next page.
+	 */
+	public void goToPage(String name) {
+		for(EditionPanel panel : editionPanels.values())
+			panel.goToPage(name);
+		updatePageLabel();
+
+	}
+
+	/**
+	 * Previous text.
+	 */
+	public void previousText(boolean fromNextText) {
+		for(EditionPanel panel : editionPanels.values())
+			panel.previousText(fromNextText);
+		updatePageLabel();
+	}
+
+	/**
+	 * Next text.
+	 */
+	public void nextText() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.nextText();
+		updatePageLabel();
+	}
+
+	/**
+	 * Previous text.
+	 */
+	public void firstText() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.firstText();
+		updatePageLabel();
+	}
+
+	/**
+	 * Next text.
+	 */
+	public void lastText() {
+		for(EditionPanel panel : editionPanels.values())
+			panel.lastText();
+		updatePageLabel();
+	}
+
+	public Composite getEditionArea() {
+		return editionsArea;
+	}
+
+	public Composite getUpperToolbarArea() {
+		return toolbarsArea;
+	}
+
+	public Composite getLowerToolbarArea() {
+		return controlsArea;
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.internal.browser.WebBrowserEditor#createPartControl(org.eclipse.swt.widgets.Composite)
+	 */
+	@Override
+	public void createPartControl(Composite parent) {
+		FormLayout mainLayout = new FormLayout();
+		parent.setLayout(mainLayout);
+
+		toolbarsArea = new Composite(parent, SWT.NONE);
+		GridLayout toolbarsLayout = new GridLayout(1, true);
+		toolbarsLayout.marginBottom = toolbarsLayout.marginHeight = 0;
+		toolbarsLayout.marginTop = toolbarsLayout.marginWidth = 0;
+		toolbarsLayout.horizontalSpacing = 2;
+		toolbarsArea.setLayout(toolbarsLayout);
+
+		editionsArea = new Composite(parent, SWT.NONE);
+		GridLayout editionLayout = new GridLayout();
+		editionLayout.marginBottom = editionLayout.marginHeight = 0;
+		editionLayout.marginTop = editionLayout.marginWidth = 0;
+		editionLayout.horizontalSpacing = 2;
+		editionsArea.setLayout(editionLayout);
+
+		controlsArea = new Composite(parent, SWT.NONE);
+		GridLayout subLayout = new GridLayout(17, false);
+		subLayout.marginBottom = subLayout.marginHeight = 0;
+		subLayout.marginTop = subLayout.marginWidth = 0;
+		subLayout.horizontalSpacing = 2;
+		controlsArea.setLayout(subLayout);
+
+		//agencing panels : upper toolbar, edition and bottom
+		FormData upperFormData = new FormData();
+		upperFormData.top = new FormAttachment(0);
+		upperFormData.bottom = new FormAttachment(editionsArea);
+		upperFormData.left = new FormAttachment(0);
+		upperFormData.right = new FormAttachment(100);
+		toolbarsArea.setLayoutData(upperFormData);
+		FormData middleFormData = new FormData();
+		middleFormData.top = new FormAttachment(toolbarsArea);
+		middleFormData.bottom = new FormAttachment(controlsArea);
+		middleFormData.left = new FormAttachment(0);
+		middleFormData.right = new FormAttachment(100);
+		editionsArea.setLayoutData(middleFormData);
+		FormData lowerFormData = new FormData();
+		//lowerFormData.top = new FormAttachment(70);
+		lowerFormData.bottom = new FormAttachment(100);
+		lowerFormData.left = new FormAttachment(0);
+		lowerFormData.right = new FormAttachment(100);
+		controlsArea.setLayoutData(lowerFormData);
+
+		//spacer
+		new Label(controlsArea, SWT.NONE).setText("  "); //$NON-NLS-1$
+
+		// Edition names label
+		editionsChooser = new Button(controlsArea, SWT.PUSH);
+		editionsChooser.setText(StringUtils.join(editionNames, " | ")); //$NON-NLS-1$
+
+		if (corpus.getEditionNames().size() > 1) {			
+
+			editionsChooser.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetSelected(SelectionEvent e) {
+					try {
+						Shell shell = e.display.getActiveShell();
+						EditionSelectorDialog d = new EditionSelectorDialog(shell, corpus, editionNames);
+
+						if (corpus.getEditionNames().size() > 1 && d.open() == Window.OK) {
+							Object[] rez = d.getResult();
+							editionNames = new String[rez.length];
+							for(int i = 0 ; i < rez.length ; i++) editionNames[i] = rez[i].toString();
+							editionsChooser.setText(StringUtils.join(editionNames, " | ")); //$NON-NLS-1$
+							openEditions(corpus, text, editionNames);
+							firstPage();
+						} else if (corpus.getEditionNames().size() == 1) {
+							editionNames = new String[]{corpus.getEditionNames().get(0)};
+							editionsChooser.setText(StringUtils.join(editionNames, " | ")); //$NON-NLS-1$
+							openEditions(corpus, text, editionNames);
+							firstPage();
+						} else {
+							System.out.println(SynopticEditionUIMessages.SynopticEditionEditor_5);
+						}
+					} catch (Exception e2) {
+						org.txm.rcp.utils.Logger.printStackTrace(e2);
+						System.out.println(SynopticEditionUIMessages.SynopticEditionEditor_6+e2);
+					}
+				}
+
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) { }
+			});
+		} else {
+			editionsChooser.setEnabled(false);
+		}
+
+		supplementaryButtonComposite = new Composite(controlsArea, SWT.NONE);
+		supplementaryButtonComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
+
+		// Navigation buttons
+
+		Button first = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+		Button previous = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+		page_text = new org.eclipse.swt.widgets.Text(controlsArea, SWT.BORDER);
+		page_label = new Label(controlsArea, SWT.NONE);
+		Button next = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+		Button last = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+
+
+		Button firstText = new Button(controlsArea, SWT.FLAT);
+		Button previousText = new Button(controlsArea, SWT.FLAT);
+		new Label(controlsArea, SWT.NONE).setText(" ");
+		Button nextText = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+		Button lastText = new Button(controlsArea, SWT.FLAT|SWT.PUSH);
+
+		// Layouts data
+
+		editionsChooser.setLayoutData(new GridData(GridData.BEGINNING,GridData.CENTER, false, false));
+
+		GridData buttonGridData = new GridData(GridData.FILL,GridData.CENTER, false, false);
+		buttonGridData.widthHint = 30;
+		buttonGridData.heightHint = 30;
+		firstText.setLayoutData(buttonGridData);
+		previousText.setLayoutData(buttonGridData);
+		GridData centerButtonGridData = new GridData(GridData.END,GridData.CENTER, true, true);
+		centerButtonGridData.widthHint = 30;
+		centerButtonGridData.heightHint = 30;
+		first.setLayoutData(centerButtonGridData);
+		previous.setLayoutData(buttonGridData);
+
+		// set sizes
+
+		GridData gdata = new GridData(GridData.END,GridData.CENTER, false, false);
+		gdata.minimumWidth = 40;
+		gdata.widthHint = 40;
+		page_text.setLayoutData(gdata);
+		page_label.setLayoutData(new GridData(GridData.BEGINNING,GridData.CENTER, false, false));
+
+		next.setLayoutData(buttonGridData);
+		centerButtonGridData = new GridData(GridData.BEGINNING, GridData.CENTER, true, true);
+		centerButtonGridData.widthHint = 30;
+		centerButtonGridData.heightHint = 30;
+		last.setLayoutData(centerButtonGridData);
+		nextText.setLayoutData(buttonGridData);
+		lastText.setLayoutData(buttonGridData);
+
+		GridData supplementaryButtonCompositeLayoutData = new GridData(GridData.BEGINNING, GridData.CENTER, false, true);
+		supplementaryButtonComposite.setLayoutData(supplementaryButtonCompositeLayoutData);
+
+		if (editionsChooser != null)
+			editionsChooser.setLayoutData(new GridData(GridData.BEGINNING,GridData.CENTER, false, true));
+		//else spacer.setLayoutData(new GridData(GridData.END,GridData.CENTER, true, true));
+
+		// set labels
+		page_label.setText(""); //$NON-NLS-1$
+		firstText.setImage(IImageKeys.getImage(IImageKeys.CTRLREWINDSTART));
+		firstText.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_0); 
+		previousText.setImage(IImageKeys.getImage(IImageKeys.CTRLREWIND));
+		previousText.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_1); 
+		first.setImage(IImageKeys.getImage(IImageKeys.CTRLSTART)); 
+		first.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_3); 
+		previous.setImage(IImageKeys.getImage(IImageKeys.CTRLREVERSE));
+		previous.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_4); 
+		next.setImage(IImageKeys.getImage(IImageKeys.CTRLPLAY));
+		next.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_7); 
+		last.setImage(IImageKeys.getImage(IImageKeys.CTRLEND));
+		last.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_8);
+		nextText.setImage(IImageKeys.getImage(IImageKeys.CTRLFASTFORWARD));
+		nextText.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_10); 
+		lastText.setImage(IImageKeys.getImage(IImageKeys.CTRLFASTFORWARDEND));
+		lastText.setToolTipText(SynopticEditionUIMessages.SynopticEditionEditor_11); 
+
+		// browse available extension points
+		try {		
+			IConfigurationElement[] config = Platform.getExtensionRegistry()
+					.getConfigurationElementsFor("org.txm.synopticeditor.toolbarbutton");
+			//Log.warning(Messages.ApplicationWorkbenchAdvisor_15+config.length);
+			for (IConfigurationElement e : config) {
+				Object o = e.createExecutableExtension("class"); //$NON-NLS-1$
+				if (o instanceof ToolbarButton) {
+					ToolbarButton tb = ((ToolbarButton) o);
+					Composite b = tb.getToolbarButton(supplementaryButtonComposite, this);
+					//b.setLayoutData(buttonGridData);
+					toolbarButtons.add(tb);
+				}
+			}
+		} catch (Exception ex) {
+			System.out.println(ex.getMessage());
+		}
+
+		page_text.addKeyListener(new KeyListener() {
+
+			@Override
+			public void keyReleased(KeyEvent e) {
+				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
+					goToPage(page_text.getText());
+				}
+			}
+
+			@Override
+			public void keyPressed(KeyEvent e) {}
+		});
+		// set listeners
+		first.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				firstPage();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				firstPage();
+			}
+		});
+		previous.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				previousPage();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				previousPage();
+			}
+		});
+		next.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				nextPage();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				nextPage();
+			}
+		});
+		last.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				lastPage();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				lastPage();
+			}
+		});
+		nextText.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				nextText();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				nextText();
+			}
+		});
+		// set listeners
+		previousText.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				previousText(false);
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				previousText(false);
+			}
+		});
+		lastText.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				lastText();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				lastText();
+			}
+		});
+		// set listeners
+		firstText.addSelectionListener(new SelectionListener() {
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {
+				firstText();
+			}
+
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				firstText();
+			}
+		});
+
+		// set Layouts
+		FormLayout parentLayout = new FormLayout();
+		parent.setLayout(parentLayout);
+
+		parent.pack();
+
+		openEditions(corpus, text, editionNames);
+	}
+
+	/**
+	 * Opens the default corpus edition with the first Text
+	 * 
+	 * @param corpus
+	 */
+	public boolean openEditions(Corpus corpus) {
+		if (corpus == null) return false;
+		return openEditions(corpus, corpus.getFirstText(), corpus.getDefaultEdition());
+	}
+
+	/**
+	 * update editor title using the first panel only 
+	 */
+	private void updatePageLabel() {
+		for (EditionPanel p : editionPanels.values()) {
+			this.setPartName(p.getCurrentPage().getEdition().getText().getName()+ " - "+p.getCurrentPage().getName()); //$NON-NLS-1$
+			page_text.setText(p.getCurrentPage().getName());
+			page_label.setText(" / "+p.getCurrentPage().getEdition().getNumPages()); //$NON-NLS-1$
+			controlsArea.layout();
+			return;
+		}
+	}
+
+	public boolean openEditions(Corpus corpus, String textID, String... editionNames) {
+		Text text = corpus.getText(textID);
+		if (text == null) return false;
+		return openEditions(corpus, text, editionNames);
+	}
+
+	/**
+	 * Opens a list of edition corpus
+	 * @param corpus
+	 * @param editionNames
+	 */
+	public boolean openEditions(Corpus corpus, Text text, String... editionNames) {
+
+		// remove previous EditionPanel
+		for (EditionPanel panel : editionPanels.values()) {
+			panel.dispose();
+		}
+		editionPanels = new LinkedHashMap<String, EditionPanel>();
+
+		editionsArea.setLayout(new GridLayout(editionNames.length, true));
+
+		for (int i = 0 ; i < editionNames.length ;i++) {
+			String editionName = editionNames[i];
+			//System.out.println("EDITION NAME: "+editionName);
+			Composite container = editionsArea;//.getContainer(i);
+			Edition edition = text.getEdition(editionName);
+			if (edition != null) {
+				EditionPanel panel = new EditionPanel(this, container, SWT.BORDER, edition);
+				panel.initSelectionProvider();
+
+				if (i == 0) { // TODO: how to manage multiple menumanager -> the text selection does not work only the first panel selection is used
+					panel.initMenu();
+					getSite().registerContextMenu(panel.getMenuManager(), panel.getSelectionProvider());
+				}
+
+				editionPanels.put(editionName, panel);
+			} else {
+				System.out.println(SynopticEditionUIMessages.SynopticEditionEditor_9+editionName);
+			}
+		}
+		editionsArea.layout();
+		return true;
+	}
+
+	/**
+	 * 
+	 * //TODO: add getDefaultEditions to Corpus object
+	 * 
+	 * @param corpus
+	 * @return a list of default editions
+	 */
+	public String[] getDefaultEditions(Corpus corpus) {
+		String defaultEdition = corpus.getDefaultEdition();
+		if (defaultEdition.contains(",")) { //$NON-NLS-1$
+			return defaultEdition.split(","); //$NON-NLS-1$
+		} else {
+			return new String[]{defaultEdition};
+		}
+	}
+
+	@Override
+	public void doSave(IProgressMonitor monitor) {
+		for (ToolbarButton b : toolbarButtons) {
+			b.save();
+		}
+		firePropertyChange(IEditorPart.PROP_DIRTY);
+	}
+
+	@Override
+	public void doSaveAs() {
+		return;
+	}
+
+	@Override
+	public void init(IEditorSite site, IEditorInput input)
+			throws PartInitException {
+		setSite(site);
+		setInput(input);
+
+		corpus = ((SynopticEditorInput) getEditorInput()).getCorpus();
+		corpus = corpus.getMainCorpus();
+		text = ((SynopticEditorInput) getEditorInput()).getText();
+		editionNames = ((SynopticEditorInput) getEditorInput()).getEditions();
+
+		IPartListener2 pl = new IPartListener2() {
+			// ... Other methods
+			public void partClosed(IWorkbenchPartReference partRef) {
+				if (partRef.getId().equals(ID)) { // called after this.doSave() 
+					//System.out.println("EVENT partClosed");
+					for (ToolbarButton b : toolbarButtons) {
+						if (b.isDirty()) b.discardChanges();
+					}
+				}
+			}
+
+			@Override
+			public void partActivated(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partBroughtToTop(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partDeactivated(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partOpened(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partHidden(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partVisible(IWorkbenchPartReference partRef) { }
+
+			@Override
+			public void partInputChanged(IWorkbenchPartReference partRef) { }
+
+		};
+		this.getEditorSite().getPage().addPartListener(pl);
+	}
+
+	@Override
+	public boolean isDirty() {
+		boolean dirty = false;
+		for (ToolbarButton b : toolbarButtons) {
+			dirty = dirty || b.isDirty();
+		}
+		return dirty;
+	}
+
+	public boolean isDisposed() {
+		return editionsArea.isDisposed();
+	}
+
+	@Override
+	public boolean isSaveAsAllowed() {
+		return false;
+	}
+
+	@Override
+	public void setFocus() {
+
+	}
+
+	public void backToText(Text text, String line_wordid) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.backToText(text, line_wordid);
+		}
+		updatePageLabel();
+		
+		for (ToolbarButton button : this.toolbarButtons) {
+			button.onBackToText(text, line_wordid);
+		}
+	}
+
+	public void reloadPage() {
+		for (EditionPanel p : editionPanels.values()) {
+			p.reloadPage();
+		}
+	}
+
+	@Override
+	public String getTextSelection() {
+		String sel = null;
+		for (EditionPanel p : editionPanels.values()) {
+			sel = p.getTextSelection();
+			if (sel != null) return sel;
+		}
+		return "";
+	}
+
+	@Override
+	public Corpus getCorpus() {
+		return corpus;
+	}
+
+	public EditionPanel getEditionPanel(int i) {
+		int n = 0;
+		for (EditionPanel p : editionPanels.values()) {
+			if (n == i) return p;
+		}
+		return null;
+	}
+
+	/**
+	 * 
+	 * @return the first and last word ID covered by the text selection of the first EditionPanel
+	 */
+	public Object getWordSelection() {
+		for (EditionPanel p : editionPanels.values()) {
+			return p.getWordSelection();
+		}
+		return null;
+	}
+
+	/**
+	 * 
+	 * @param text2 the Text to set
+	 * @param refresh if true set the first Text page
+	 */
+	public void setText(Text text2, boolean refresh) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.setText(text2, refresh);
+		}
+	}
+
+	public void setFocusedWordID(String focusid) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.setFocusedWordID(focusid);
+		}
+	}
+
+	/**
+	 *  NOT DONE
+	 *  
+	 * @param pos
+	 */
+	public void setHighlightedArea(HashSet<int[]> positions) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.setHighlightedArea(positions);
+		}
+	}
+
+	public void updateWordStyles() {
+		for (EditionPanel p : editionPanels.values()) {
+			p.updateWordStyles();
+		}
+	}
+
+	public void addFontWeightWordsById(String weight, List<String> previousSelectedUnitIDS) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.addFontWeightWordsById(weight, previousSelectedUnitIDS);
+		}
+	}
+
+	public void removeFontWeightWordsById(List<String> previousSelectedUnitIDS) {
+		for (EditionPanel p : editionPanels.values()) {
+			p.removeFontWeightWordsById(previousSelectedUnitIDS);
+		}
+	}
+
+	public void fireIsDirty() {
+		this.firePropertyChange(IEditorPart.PROP_DIRTY);
+	}
+
+	/**
+	 * Clear all highlighted words
+	 */
+	public void removeHighlightWords() {
+		for (EditionPanel p : editionPanels.values()) {
+			p.removeHighlightWords();
+		}
+	}
+}
\ No newline at end of file

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionSelectorDialog.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionSelectorDialog.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/EditionSelectorDialog.java	(revision 653)
@@ -0,0 +1,52 @@
+package org.txm.synopticedition.rcp.editors;
+
+import org.eclipse.jface.viewers.ILabelProvider;
+import org.eclipse.jface.viewers.ILabelProviderListener;
+import org.eclipse.swt.graphics.Image;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.dialogs.ElementListSelectionDialog;
+import org.txm.objects.Corpus;
+import org.txm.synopticedition.rcp.messages.SynopticEditionUIMessages;
+
+public class EditionSelectorDialog extends ElementListSelectionDialog {
+
+	public EditionSelectorDialog(Shell parent, Corpus corpus, String[] defaultSelection) {
+		super(parent, new ILabelProvider() {
+			@Override
+			public void removeListener(ILabelProviderListener listener) { }
+
+			@Override
+			public boolean isLabelProperty(Object element,
+					String property) {
+				return false;
+			}
+
+			@Override
+			public void dispose() { }
+
+			@Override
+			public void addListener(ILabelProviderListener listener) { }
+
+			@Override
+			public Image getImage(Object element) {
+				return null;
+			}
+
+			@Override
+			public String getText(Object element) {
+				return element.toString();
+			}
+		});
+
+		setTitle(SynopticEditionUIMessages.EditionSelectorDialog_0);
+		setMessage(SynopticEditionUIMessages.EditionSelectorDialog_1);
+		setMultipleSelection(true);
+		setElements(corpus.getEditionNames().toArray());
+		setFilter("*"); //$NON-NLS-1$
+		
+		if (defaultSelection == null) {
+			defaultSelection = new String[]{corpus.getDefaultEdition()};
+		}
+		this.setInitialSelections(defaultSelection);
+	}
+}
\ No newline at end of file

